function TwitterLib(requestTimeout, onAuthenticated, onHitsUpdated, microbloggingService, baseUrl, baseOauthUrl, baseSigningUrl, baseOauthSigningUrl, baseSearchUrl, oauthTokenData) {
  this.remainingHitsCount = 350;
  this.nextHitsReset = 0;
  this.onAuthenticated = onAuthenticated;
  this.onHitsUpdated = onHitsUpdated;
  this.hourlyLimit = 350;
  this.microbloggingService = microbloggingService;
  this.requestTimeout = requestTimeout;

  if(!baseUrl.match(/\/$/)) {
    baseUrl = baseUrl + '/';
  }
  TwitterLib.URLS = {
    BASE: baseUrl,
    BASE_OAUTH: baseOauthUrl,
    BASE_SIGNING: baseSigningUrl,
    BASE_OAUTH_SIGNING: baseOauthSigningUrl,
    BASE_SEARCH: baseSearchUrl
  };
  setTimeout(function() {
    onAuthenticated();
  }, 0);
}
TwitterLib.prototype = {
  username: function() {
    return 'iamme';
  },
  authenticated: function() {
    return true;
  },
  tokenRequested: function() {
    return true;
  },
  authenticating: function() {
    return false;
  },
  startAuthentication: function() {

  },
  getAccessToken: function(pinNumber, callback) {
    callback(true, null);
  },
  ajaxRequest: function(url, callback, context, params, httpMethod, useSearchAPI) {
    if(!httpMethod)
      httpMethod = "GET";
    if(!params)
      params = {};
    console.log('Fake request: ' + httpMethod + ' - ' + url + '?' + $.param(params));
    
    
    
    if(url == 'statuses/home_timeline') {
      
    }

    callback(true, [], null, context);
  },

  normalizeTweets: function(tweets) {
    for(var i = 0, len = tweets.length; i < len; ++i) {
      var ti = tweets[i];
      if(!ti.user) {
        // DMs
        ti.user = ti.sender;
      }
      if(!ti.user) {
        // Search result
        ti.user = {
          name: ti.from_user,
          screen_name: ti.from_user,
          profile_image_url: ti.profile_image_url
        };
      }
    }
  },

  remainingHitsInfo: function() {
    return [this.remainingHitsCount, this.nextHitsReset, this.hourlyLimit];
  },

  updateHourlyHitsLimit: function() {
    var _this = this;
    this.ajaxRequest("account/rate_limit_status", function(success, data) {
      if(success) {
        _this.hourlyLimit = data.hourly_limit;
      }
    });
  },

  tweet: function(callback, msg, replyId) {
    var params = { status: msg };
    if(replyId) {
      params.in_reply_to_status_id = replyId;
    }
    this.ajaxRequest('statuses/update', callback, null, params, "POST");
  },

  retweet: function(callback, id) {
    this.ajaxRequest('statuses/retweet/' + id, callback, null, null, "POST");
  },

  destroy: function(callback, id) {
    this.ajaxRequest('statuses/destroy/' + id, callback, null, null, "POST");
  },

  destroyDM: function(callback, id) {
    this.ajaxRequest('direct_messages/destroy/' + id, callback, null, null, "POST");
  },

  favorite: function(callback, id) {
    this.ajaxRequest('favorites/create/' + id, callback, null, null, "POST");
  },

  unFavorite: function(callback, id) {
    this.ajaxRequest('favorites/destroy/' + id, callback, null, null, "POST");
  },

  lists: function(callback) {
    this.ajaxRequest(this.username() + '/lists', callback, null, null, "GET");
  },

  subs: function(callback) {
    this.ajaxRequest(this.username() + '/lists/subscriptions', callback, null, null, "GET");
  },
  
  timeline: function(timeline_path, callback, context, params) {
    this.ajaxRequest(timeline_path, callback, context, params);
  },

  searchTimeline: function(callback, context, params) {
    params['result_type'] = 'recent';
    this.ajaxRequest('', callback, context, params, "GET", true);
  },

  blockedUserIds: function(callback) {
    this.ajaxRequest('blocks/blocking/ids', callback, null, null, "GET");
  },
};