const AMAROK_VER = function(){
	var ver = Amarok.Info.version();
	ver = ver.replace(/\D/g,"")-0;
	if (ver == 0) ver = 230;
	while (ver<100)
		ver*=10;
	while (ver>1000)
		ver/=10;
	return ver;
}();
//const AMAROK_VER = 230;

//Amarok.alert(AMAROK_VER);

//---------- String.replace patch ------------------------------------------

try{
	"a string".capitalize();
}catch(e){
	alert("String.prototype.replace patch applied\n"+e);
	String.prototype.replace2 = String.prototype.replace;
	String.prototype.replace = function(expr, rep){
		if (typeof(rep) != "function")
			return this.replace2(expr, rep);
		var st = this;
		if (expr.global){
			var a = this.match(expr);
			for(var i=0; i<a.length; i++){
//				alert(st + " " + a[i] + " " + rep(a[i]));
//				st = st.replace2(new RegExp(a[i],+expr.multiline?"m":""+expr.ignoreCase?"i":""),rep(a[i]));
				st = st.replace2(a[i],rep(a[i]));
			}
		}
		return st;
	}
}
//alert("&#87;&#65;".escapeNumberedChars());

//---------- GUI settings patch --------------------------------------------

try{
	JSON.pack(DEFAULTS).unpack();
//	Amarok 2.0.x non Ubuntu users can comment the following line to try enabling GUI settings
	if (AMAROK_VER < 210) throw new Error("Amarok version " + Amarok.Info.version());
//	throw new Error();
}catch(e){
	alert("disable GUI settings patch applied\n"+e);
//	SiteManager.createGUISettings = function(){};
	WindowController.prototype.registerButton = function(){};
	SiteManager.changeSettingsLocation = Amarok.Info.scriptPath()+"/main.js";

	SettingsControl.prototype.init= function(){
		return this.defaults;
	}
	SettingsControl.prototype.restoreDefaults = SettingsControl.prototype.init;
}

//---------- Amarok 2.1 patch ------------------------------------------

try{
	DataDownloader.prototype;
}catch(e){
	alert("DataDownloader patch applied\n"+e);
	//	no DataDownloader in Amarok 2.0
	LyricsClass.prototype.fetchReply = function(handler,info){
//		new DataDownloader( new QUrl(this.getUrl(info)), handler);
		new Downloader( new QUrl(this.getUrl(info)), handler, this.charset);
	}

	LyricsClass.prototype.decodeReply = function(reply){
		return reply;
	}
}

//---------- Amarok 2.4 patch ------------------------------------------

try{
	if (AMAROK_VER < 240) throw new Error("Amarok version " + Amarok.Info.version());
}catch(e){
	alert("suggestions patch applied\n"+e);
	//	some minor suggestion bugs

//	Amarok.Lyrics.fetchLyrics contains "&amp;" instead of "&" in title and artist
	SiteManager.fetchLyrics2 = SiteManager.fetchLyrics;
	SiteManager.fetchLyrics = function(info){
//		Amarok.alert(title);
		info.title = info.title.replace(/&amp;/g,"&");
		info.artist = info.artist.replace(/&amp;/g,"&");
		SiteManager.fetchLyrics2(info);
	}

	String.prototype.encodeSuggestionURL = function(){
		return this.replace(/%/g,"%;");			//	amarok doesn't handle '%' character well?
	}

	String.prototype.decodeSuggestionURL = function(){
		return this.replace(/\%;/g,"%");		//	amarok doesn't handle '%' character well?
	}

	String.prototype.formatSuggestionInfo = function(){
		var st = this.replace(/\:/g,"");
		return st.replace(/ *([-|]) */g,"-");		//	suggestion artist and title may not contain space-space
	}
}
